﻿<?php
	/*
	* ZZZ KNOWLEDGE BASE
	* ==================
	* 
	* Copyright © 2012-2014 ZZZ Ltd. - BULGARIA. All rights reserved.
	* 
	* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	* THE SOFTWARE.
	*/
    class Socket
    {
        var $m_host  = "";
        var $m_port  = 0;
        var $m_sock;
		var $buf = "";
         
        function Socket($host, $port)
        {
            $this->m_host = $host;
            $this->m_port = $port;
        }
         
        function Connect()
        {
			$seconds = 10;
			$milliseconds = 0;
            $this->m_sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);

            return socket_connect($this->m_sock, gethostbyname($this->m_host), $this->m_port);
        }
         
        function send($data)
        {
            if(socket_write($this->m_sock, $data) == false)
            {
                printf("** failed to send(%s) **\n");

                return;
            }
			
        }
         
        function read($length = 2048)
        {
            return socket_read($this->m_sock, $length);
        }
         
        function kill()
        {
            socket_close($this->m_sock);
        }
		
		function println($s)
		{
			$this->send($s."\r\n");
		}
		
		function readLine()
		{
			$response = '';
			while($resp = socket_read($this->m_sock, 1024)) {
				if(!$resp)
					break;
				$response .= $resp;
			}
			return $response;
		}
	}

	$host = "localhost";
	$port = 5555;

	function zzz_exec($program) {
		global $host;
		global $port;
		$result="";
		if($program != "") {
			$Connection = new Socket($host, $port);
			if($Connection->Connect()){
				$Connection->println($program);
				$result = $Connection->readLine();
				$Connection->kill();
			}
		}
		return $result;
	}
?>